:warning: **This SDK has been deprecated as of January 2022.** The new NEM & Symbol JavaScript SDK can be found [here](https://github.com/symbol/symbol/tree/dev/sdk/javascript). 

# Symbol SDK for TypeScript and JavaScript

[![npm version](https://badge.fury.io/js/symbol-sdk.svg)](https://badge.fury.io/js/symbol-sdk)
[![Build Status](https://api.travis-ci.com/nemtech/symbol-sdk-typescript-javascript.svg?branch=main)](https://travis-ci.com/nemtech/symbol-sdk-typescript-javascript)
[![Coverage Status](https://coveralls.io/repos/github/nemtech/symbol-sdk-typescript-javascript/badge.svg)](https://coveralls.io/github/nemtech/symbol-sdk-typescript-javascript?branch=travis-ci)
[![License](https://img.shields.io/badge/License-Apache%202.0-blue.svg)](https://opensource.org/licenses/Apache-2.0)

The Symbol SDK for TypeScript / JavaScript allows you to develop web, mobile, and Node.js applications.

## Important Notes

### _Catapult-Server_ Network Compatibility (catapult-server@0.10.0.8)

Symbol network launched [catapult-client](https://github.com/symbol/catapult-client/releases/tag/v1.0.0.0), **it is recommended to use this package's 1.0.0 version and upwards for the Symbol public network**.

Find the complete release notes [here](CHANGELOG.md).

## Requirements

### NodeJS

- NodeJS 10.X.X and above (from v0.18.0)

## Installation

```bash
npm install symbol-sdk rxjs
```

## Usage

Surf the [documentation][docs] to get started into Symbol development.
You will find self-paced guides and useful code snippets using the TypeScript/Javascript SDK.

To get the full description of the available classes and their functions, check the [SDK reference][sdk-ref].

## Getting help

Use the following available resources to get help:

- [Symbol Documentation][docs]
- [Symbol SDK Typescript/Javascript Reference][sdk-ref]
- Join the community [Discord server][discord]
- If you found a bug, [open a new issue][issues]

## Contributing

Contributions are welcome and appreciated.
Check [CONTRIBUTING](CONTRIBUTING.md) for information on how to contribute.

You can also find useful notes for developers under our documentation [guidelines][guidelines] section.

## License

Copyright (c) 2018-present NEM
Licensed under the [Apache License 2.0](LICENSE)

[self]: https://github.com/symbol/symbol-sdk-typescript-javascript
[docs]: http://docs.symbolplatform.com/getting-started/setup-workstation.html
[issues]: https://github.com/symbol/symbol-sdk-typescript-javascript/issues
[sdk-ref]: https://docs.symbolplatform.com/references/typescript-sdk.html
[guidelines]: https://docs.symbolplatform.com/contribute/contributing.html#sdk
[discord]: https://discord.com/invite/xymcity
